#version 410 core

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uvCoord;

uniform mat4 VP;
uniform mat4 M;
uniform vec4 clipPlane;

uniform float terrainWidth;
uniform float gridCount;

out vec3 vertexPosition;
out vec3 vertexNormal;
out vec2 vertexUVCoord;

void main()
{
	gl_Position = VP * M * vec4(position, 1.0);
	vertexPosition = vec3(M * vec4(position, 1.0));
	gl_ClipDistance[0] = dot(clipPlane, M * vec4(position, 1.0));
	vertexNormal = vec3(M * vec4(normal, 0.0));
	vertexUVCoord = uvCoord * gridCount;
}